﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace usandoDadosBinarios
{
    public partial class Form1 : Form
    {
        private string foto = null;
        private SqlConnection conSQL;

        public Form1()
        {
            InitializeComponent();
            conSQL = new SqlConnection("Data Source=.\\SQLEXPRESS;AttachDbFilename='C:\\Documents and Settings\\macoratti\\Meus documentos\\Visual Studio 2008\\Projects\\usandoDadosBinarios\\usandoDadosBinarios\\Cadastro.mdf';Integrated Security=True;Connect Timeout=30;User Instance=True");
            atualizaGrid();
        }

        private void btnCarregaFoto_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();

            dlg.Title = "Abrir Foto";
            dlg.Filter = "JPG (*.jpg)|*.jpg"
                + "|All files (*.*)|*.*";

            if (dlg.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    picFoto.Image = new Bitmap(dlg.OpenFile());
                    foto = dlg.FileName;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Não foi possivel carregar a foto: " + ex.Message);
                }
            }

            dlg.Dispose();
        }

        private void IncluiDados_Click(object sender, EventArgs e)
        {
            String nome = txtNome.Text;
            String endereco = txtEndereco.Text;
            String cargo = txtCargo.Text;
            DateTime admissao = DateTime.Now;
            if (txtNome.Text.Equals(""))
            {
                MessageBox.Show("Informe o nome do funcionario.");
            }
            else
            {
                //IncluiFuncionario(nome, endereco, cargo, admissao,foto);
                IncluiFuncionario(nome, endereco, cargo, admissao, foto);
                barraStatus.Text = "Funcionário incluido no banco de dados";
                atualizaGrid();
            }
        }

        private void Seleciona_Click(object sender, EventArgs e)
        {
            if (txtNome.Text.Equals(""))
            {
                MessageBox.Show("Informe o nome do funcionário.");
                return;
            }
            else
            {
                getFuncionario(txtNome.Text);
            }

            barraStatus.Text = "Arquivo Salvo no sistema";
        }

        // **** Le o BLOB a partir do banco de dados e salva no sistema de arquivos
        public void getFuncionario(string nome)
        {
            SqlCommand getFunci = new SqlCommand(
                                   "SELECT funciID, foto " +
                                   "FROM Funcionarios " +
                                   "WHERE nome = @Nome ", conSQL);


            getFunci.Parameters.Add("@Nome", SqlDbType.NVarChar, 50).Value = nome;

            FileStream fs;                                  // Escreve o BLOB para o arquivo (*.bmp).
            BinaryWriter bw;                                // Define um Streams para o objeto 
            int tamanhoBuffer = 100;                        // Tamanho do buffer do BLOB
            byte[] byteSaida = new byte[tamanhoBuffer];     // o buffer BLOB byte[] para ser preenchido com GetBytes.
            long retorno;                                   // Os bytes retornados de GetBytes.
            long inicioIndice = 0;                          // A posicao inicial no BLOB de saida
            string funci_id = "";                           // O codigo do funcionario em uso no arquivo

            // Abre a conexão e le os dados no DataReader.
            conSQL.Open();
            SqlDataReader mReader = getFunci.ExecuteReader(CommandBehavior.SequentialAccess);

            while (mReader.Read())
            {
                // Obtem o codigo que precisa existir antes de pegar o funcionario
                funci_id = mReader.GetInt32(0).ToString();

                // Cria o arquivo para tratar a saida dos dados
                fs = new FileStream("funcionario" + funci_id + ".jpg", FileMode.OpenOrCreate, FileAccess.Write);
                bw = new BinaryWriter(fs);

                // Reseta o byte de inicio para o novo BLOB.
                inicioIndice = 0;

                // Le os bytes no byteSaida[] e retem o numero de bytes retornados
                retorno = mReader.GetBytes(1, inicioIndice, byteSaida, 0, tamanhoBuffer);

                // Continua lendo e escrevendo enquanto existir bytes ate completar o tamanho do buffer
                while (retorno == tamanhoBuffer)
                {
                    bw.Write(byteSaida);
                    bw.Flush();

                    //Reposiciona o inidice de inicio para o fim ultimo buffer e preenche o buffer
                    inicioIndice += tamanhoBuffer;
                    retorno = mReader.GetBytes(1, inicioIndice, byteSaida, 0, tamanhoBuffer);
                }

                // Escreve o restante do buffer
                bw.Write(byteSaida, 0, (int)retorno);
                bw.Flush();

               // fecha o arquivo de saida
                bw.Close();
                fs.Close();
            }

            // fecha o datareader e a conexao
            mReader.Close();
            conSQL.Close();
        }

        // Le a imagem do arquivo de sistema e inclui no banco de dados
        public void IncluiFuncionario(
            string pnome,
            string pendereco,
            string pcargo,
            DateTime padmissao,
            string pcaminhoFoto)
        {

            // Le a imagem em um array de bytes do arquivo de sistemas
            byte[] fotoImagem = GetFoto(pcaminhoFoto);

            // MOnta a instrucao SQL
            SqlCommand incFunci = new SqlCommand(
                "INSERT INTO Funcionarios (" +
                "nome,endereco,cargo,admissao,foto) " +
                "VALUES(@nome,@endereco,@cargo,@admissao,@foto)", conSQL);

            incFunci.Parameters.Add("@nome", SqlDbType.NVarChar, 50).Value = pnome;
            incFunci.Parameters.Add("@endereco", SqlDbType.NVarChar, 50).Value = pendereco;
            incFunci.Parameters.Add("@cargo", SqlDbType.NVarChar, 50).Value = pcargo;
            incFunci.Parameters.Add("@admissao", SqlDbType.DateTime).Value = padmissao;
            incFunci.Parameters.Add("@foto", SqlDbType.Image, foto.Length).Value = fotoImagem;

            // Abre a conexao e inclui o BLOB na tabela
            try
            {
                conSQL.Open();
                incFunci.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Erro ao incluir dados : " + ex.Message);
            }
            finally
            {
                conSQL.Close();
            }
        }

        // **** Le a imagem em um array de bytes a partir do sistema de arquivos
        public static byte[] GetFoto(string caminhoArquivoFoto)
        {
            FileStream fs = new FileStream(caminhoArquivoFoto, FileMode.Open, FileAccess.Read);
            BinaryReader br = new BinaryReader(fs);

            byte[] foto = br.ReadBytes((int)fs.Length);

            br.Close();
            fs.Close();

            return foto;
        }
        public void atualizaGrid()
        {
            //define a instrução SQL
            string strSql = "SELECT nome, endereco, cargo FROM Funcionarios";

            //cria o objeto command para executar a instruçao sql
            SqlCommand cmd = new SqlCommand(strSql, conSQL);

            //abre a conexao
            conSQL.Open();

            //define o tipo do comando 
            cmd.CommandType = CommandType.Text;
            //cria um dataadapter
            SqlDataAdapter da = new SqlDataAdapter(cmd);

            //cria um objeto datatable
            DataTable funci = new DataTable();
            try
            {
                //preenche o datatable via dataadapter
                da.Fill(funci);
                //atribui o datatable ao datagridview para exibir o resultado
                gdvFunci.DataSource = funci;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Erro ao exibir dados " + ex.Message);
            }
            finally
            {
                conSQL.Close();
            }

        }
        //public void gravaDados(
        //    string pnome,
        //    string pendereco,
        //    string pcargo,
        //    DateTime padmissao,
        //    string pcaminhoFoto)
        //{
        //    SqlDataAdapter da = new SqlDataAdapter("Select * From Funcionarios", conSQL);

        //    SqlCommandBuilder MyCB = new SqlCommandBuilder(da);
        //    DataSet ds = new DataSet("Funcionarios");

        //    da.MissingSchemaAction = MissingSchemaAction.AddWithKey;

        //    FileStream fs = new FileStream(pcaminhoFoto, FileMode.OpenOrCreate, FileAccess.Read);

        //    byte[] dadosImagem = new byte[fs.Length];
        //    fs.Read(dadosImagem, 0, System.Convert.ToInt32(fs.Length));

        //    fs.Close();

        //    da.Fill(ds, "Funcionarios");

        //    DataRow linha;
        //    linha = ds.Tables["Funcionarios"].NewRow();

        //    linha["nome"] = pnome;
        //    linha["endereco"] = pendereco;
        //    linha["cargo"] = pcargo;
        //    linha["admissao"] = padmissao;
        //    linha["foto"] = dadosImagem;

        //    ds.Tables["Funcionarios"].Rows.Add(linha);
        //    da.Update(ds, "Funcionarios");

        //    conSQL.Close();
        //    atualizaGrid();

        //}

        //public void getDados(string foto)
        //{

        //    SqlDataAdapter da = new SqlDataAdapter("Select * From Funcionarios", conSQL);
        //    SqlCommandBuilder MyCB = new SqlCommandBuilder(da);
        //    DataSet ds = new DataSet("MyImages");

        //    byte[] MyData = new byte[0];

        //    da.Fill(ds, "Funcionarios");
        //    DataRow myRow;
        //    myRow = ds.Tables["Funcionarios"].Rows[0];

        //    MyData = (byte[])myRow["foto"];
        //    int ArraySize = new int();
        //    ArraySize = MyData.GetUpperBound(0);

        //    FileStream fs = new FileStream(@foto, FileMode.OpenOrCreate, FileAccess.Write);
        //    fs.Write(MyData, 0, ArraySize);
        //    fs.Close();

        //   // string nomeDaImagem = "";

        //    long tamanhoDaImagem = 0;
        //    byte[] imagemEmBytes = null;
        //    FileInfo imagem = new FileInfo(foto);
        //    tamanhoDaImagem = imagem.Length;
        //    imagemEmBytes = new byte[Convert.ToInt32(tamanhoDaImagem)];
        //    //FileStream fs = new FileStream(nomeDaImagem, FileMode.Open, FileAccess.Read, FileShare.Read);
        //    //fs.Read(imagemEmBytes, 0, Convert.ToInt32(tamanhoDaImagem));
        //    //fs.Close();
        //    //pictureBox1.Image = Image.FromFile(nomeDaImagem);

        //}

        //public void teste()
        //{
        //    try
        //    {
        //        //Initialize SQL Server connection.
        //        //SqlConnection CN = new SqlConnection(txtConnectionString.Text);

        //        //Initialize SQL adapter.
        //        SqlDataAdapter ADAP = new SqlDataAdapter("Select * from Funcionarios", conSQL);

        //        //Initialize Dataset.
        //        DataSet DS = new DataSet();

        //        //Fill dataset with ImagesStore table.
        //        ADAP.Fill(DS, "Funcionarios");

        //        //Fill Grid with dataset.
        //        gdvFunci.DataSource = DS.Tables["Funcionarios"];
        //    }
        //    catch (Exception ex)
        //    {
        //        MessageBox.Show(ex.ToString());
        //    }

        //}

        private void button1_Click_1(object sender, EventArgs e)
        {
            txtNome.Text = "";
            txtEndereco.Text = "";
            txtCargo.Text = "";
            txtAdmissao.Text = "";
        }

        //private void button2_Click(object sender, EventArgs e)
        //{
        //    //SqlConnection cn = new SqlConnection("Your Connection String");
        //    SqlCommand cmd = new SqlCommand("Select * from Funcionarios", conSQL);
        //    SqlDataReader dr = null;
        //    int pictureColumn = 5;
        //    byte[] b = null;
        //    //Comment: Max of 2 Gb image can be copied in this array. 

        //    conSQL.Open();
        //    dr = cmd.ExecuteReader();
        //    dr.Read();
        //    dr.GetBytes(pictureColumn, 0, b, 0, b.Length);
        //    dr.Close();
        //    conSQL.Close();

        //    MessageBox.Show("Bytes read from database: " + b.Length.ToString());

        //    System.IO.Stream bs = new System.IO.MemoryStream();
        //    bs.Write(b, 0, b.Length);

        //    picFoto.Image = Image.FromStream(bs);
        //    txtNome.Text = dr["nome"].ToString();
        //    txtEndereco.Text = dr["endereco"].ToString();
        //    txtCargo.Text = dr["cargo"].ToString();
        //    txtAdmissao.Text = dr["admissao"].ToString();
            


        //    //MemoryStream stream = new MemoryStream();
        //    //try
        //    //{

            //    conSQL.Open();
            //    string sql = "Select foto from Funcionarios where nome = " + txtNome.Text;
            //    SqlCommand command = new SqlCommand(sql,conSQL);

            //    byte[] image = (byte[])command.ExecuteScalar();


            //    MemoryStream ms1 = new MemoryStream(image);

            //    picFoto.Image = Bitmap.FromStream(ms1);  //this is how it should be.  I was using Image.FromStream and was getting error.


            //}

            //finally
            //{

            //    conSQL.Close();
            //    stream.Close();

            //}


        //}
    }

}

        
